#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>
#include <math.h>
#include <windows.h>

void PrintMatrix (double* pMatrix, int RowCount, int ColCount) {
  int i, j; 
  for (i=0; i<RowCount; i++) {
    for (j=0; j<ColCount; j++)
      printf("%7.4f ", pMatrix[i*ColCount+j]);
    printf("\n");
  }
}
void ResultCalculation(double* pMatrix, int Size, double &Eps, 
  int &Iterations) {
  int i, j; 
  double dm, dmax,temp;
  Iterations = 0;   
  do {
    dmax = 0;
    for (i = 1; i < Size - 1; i++)
      for(j = 1; j < Size - 1; j++) {
        temp = pMatrix[Size * i + j];
        pMatrix[Size * i + j] = 0.25 * (pMatrix[Size * i + j + 1] + 
                                        pMatrix[Size * i + j - 1] + 
                                        pMatrix[Size * (i + 1) + j] + 
                                        pMatrix[Size * (i - 1) + j]);
        dm = fabs(pMatrix[Size * i + j] - temp);
        if (dmax < dm) dmax = dm;
      }    
      Iterations++;
}
  while (dmax > Eps);  
}

void ProcessTermination(double* pMatrix) {
  delete [] pMatrix;
}

void RandomDataInitialization (double* pMatrix, int Size) {
  int i, j; 
  srand(unsigned(clock()));
  double h = 1.0 / (Size - 1);
  for (i=0; i<Size; i++) {
    for (j=0; j<Size; j++) 
      if ((i==0) || (i== Size-1) || (j==0) || (j==Size-1))
        pMatrix[i*Size+j] = 100;
      else
        pMatrix[i*Size+j] = rand()/double(1000);
  }
}
void ProcessInitialization (double* &pMatrix, int &Size, double &Eps) {
  do {
    printf("\nEnter the grid size of the initial objects: ");
    scanf("%d", &Size);
    if (Size <= 2)
      printf("\nSize of grid must be greater than 2!\n"); 
  }
  while (Size <= 2);
  do {
    printf("\nEnter the required accuracy: ");
    scanf("%lf", &Eps);
    printf("\nChosen accuracy = %lf", Eps);
    if (Eps <= 2)
      printf("\nAccuracy must be greater than 0!\n"); 
  }
  while (Eps <= 0);
  pMatrix = new double [Size*Size];
  RandomDataInitialization(pMatrix, Size);
}
void main() {
  double* pMatrix;    
  int     Size;    
  double  Eps;        
  int     Iterations;
  double t1, t2, dt;

  printf ("Serial Gauss - Seidel algorithm\n");
  ProcessInitialization(pMatrix, Size, Eps);
  printf ("\nInitial Matrix: \n");
  PrintMatrix (pMatrix, Size, Size);
  t1=GetTickCount();
  ResultCalculation(pMatrix, Size, Eps, Iterations);
  t2=GetTickCount();
  printf ("\nResult matrix: \n");
  PrintMatrix (pMatrix, Size, Size);
  dt = (t2-t1)*1000;
  printf("\nTime: %10.5f\n", dt);
  ProcessTermination(pMatrix);
  getch(); 
}
